
#include "equivalent.h"
#include "equivalent_ext.h"
#include "equivalent_dbg.h"
#include <timer.h>
#include "io_interface.h"

#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <unistd.h>
#include <termios.h>
#include <termios.h>
#include <sys/time.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <termios.h>


////////////// Keyboard helper functions

static struct termios init_tio;

void init_keyboard()
{            
    tcgetattr(0,&init_tio);
}
void close_keyboard()
{            
    tcsetattr(0,TCSANOW,&init_tio);
}

int kbhit()
{
    struct termios tio;
    struct timeval tv;
    fd_set rfds;
    // set up terminal
    memcpy(&tio,&init_tio,sizeof(struct termios));
    tio.c_lflag &= ~(ICANON);
    tcsetattr(0,TCSANOW,&tio);
    // do not wait
    FD_ZERO(&rfds);
    FD_SET(0,&rfds);
    tv.tv_usec = 0;
    tv.tv_sec  = 0;
    select(1,&rfds,NULL,NULL,&tv);
    // back to initial terminal mode
    tcsetattr(0,TCSANOW,&init_tio);
    return (FD_ISSET(0,&rfds)?1:0);
}

int readch()
{
    int ch;
    struct termios tio;
    // set up terminal
    memcpy(&tio,&init_tio,sizeof(struct termios));
    tio.c_lflag &= ~(ICANON | ECHO);
    tcsetattr(STDIN_FILENO,TCSANOW,&tio);
    // input key
    read(0,&ch,1);
    // back to initial terminal mode
    tcsetattr(0,TCSANOW,&init_tio);
    return ch;
} 
//////////////////////





EQUIVALENT_INSTANCEDATA_T instData = EQUIVALENT_INSTANCEDATA_INIT;
static struct timespec tv = { 0, 1000 * 1000 * 100 }; // ~100ms

// the timer for "equivalent"
uint8_t timerId;

// message to state machine
EQUIVALENT_EVENT_T msg;

// a, b, enable
IO_DATA testdata = {0,0,0};
IO_DATA *pTestdata;

// dump output variables in the trace function
// trace is called if -Trace is specified
void equivalentTraceEvent(int evt){
	printIOOut();
}

int main(int argc, char* argv[]) {

	uint8_t timerStatus;
	timerId = timerCreate();
	timerSet(timerId, 20);  // set to 2s to allow user interaction

	pTestdata = &testdata;
	
	init_keyboard();
	printf("Uage. Use captial A/B/E to set inputs A/B/E to 1\n");
	printf("      Use lower case a/b/e to set inputs a/b/e to 0\n");		
	do {
		nanosleep(&tv, 0);
		timerStatus = tick(timerId);

		if (timerStatus) {
			msg = evTimeout;
		} else if(kbhit()){
			char ch=readch();
			if(ch=='A')
				testdata.a=1;
			else if(ch=='B')
				testdata.b=1;
			else if(ch=='a')
				testdata.a=0;
			else if(ch=='b')
				testdata.b=0;
			else if(ch=='E'){
				testdata.enable=1;
			}else if(ch=='e'){
				testdata.enable=0;
			}else if(ch=='q'){
				close_keyboard();
				exit(0);					
			}else{
				printf("Unknown key. Use captial A/B/E to set inputs A/B/E to 1.\n");
				printf("             Use lower case a/b/e to set inputs a/b/e to 0\n");
				msg=EQUIVALENT_NO_MSG;
			}
			}else{
				msg=EQUIVALENT_NO_MSG;
			}
			
			
		//printf("------------------\n");
		//printIOIn();
		//printf("---Execute machine\n");
		equivalent(&instData);
		//printIOOut();
		//printf("-----------------\n");

	} while (1);
	
	return 0;
}
